import math
from dataclasses import dataclass
from decimal import Decimal

k, x, p = map(int, input().split(" "))
cars = [input().split() for _ in range(int(input()))]
# k, x, p = 300, 100, 20
# cars = [["A", 50], ["B", 45], ["B", 44]]


@dataclass
class Car:
    from_city: str
    velocity: int
    all_time: int = None
    time_on_end_bridge: int = None

    @property
    def time_to_bridge(self):
        if self.from_city == "A":
            return (x * 1000) / (self.velocity * 1000 / 3600)
        return ((k - x - p) * 1000) / (self.velocity * 1000 / 3600)

    @property
    def time_from_bridge(self):
        if self.from_city == "A":
            return ((k - x - p) * 1000) / (self.velocity * 1000 / 3600)
        return (x * 1000) / (self.velocity * 1000 / 3600)

    def time_to_wait(self, cars):
        for car in cars:
            if car.time_on_end_bridge is None:
                continue
            if car.time_to_bridge < self.time_to_bridge < car.time_on_end_bridge:
                return car.time_on_end_bridge - self.time_to_bridge
        return 0


cars = sorted([Car(from_city=i[0], velocity=int(i[1])) for i in cars], key=lambda t: t.time_to_bridge)

temp = cars.copy()
while len(temp) > 0:
    car = temp[0]
    cars_in_that_time = list(filter(lambda t: t.time_to_bridge == car.time_to_bridge, temp))
    if len(cars_in_that_time) > 1:
        car = sorted(cars_in_that_time, key=lambda t: -t.time_from_bridge)[0]

    time_to_wait = car.time_to_wait(cars)

    car.all_time = time_to_wait + (k * 1000) / (car.velocity * 1000 / 3600)
    if car.from_city == "A":
        car.time_on_end_bridge = time_to_wait + ((x + p) * 1000) / (car.velocity * 1000 / 3600)
    else:
        car.time_on_end_bridge = time_to_wait + ((k - x) * 1000) / (car.velocity * 1000 / 3600)
    temp.remove(car)

print(math.ceil(max(cars, key=lambda t: t.all_time).all_time / 3600))
