﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <assert.h>
#include <bitset>
#include <deque>
#include <cmath>

using namespace std;

#define int long long
#define double long double

const double EPS = 1e-6;

const int INF = 1e9;

string ToBaseX(int a, int x) {
	string res;
	while (a / x > 0) {
		res.push_back((a % x) + '0');
		a /= x;
	}
	res += to_string(a);
	reverse(res.begin(), res.end());
	return res;
}


void solve() {
	int k, x;
	cin >> k >> x;
	double p;
	cin >> p;
	int n;
	cin >> n;
	vector<pair<char, int>> stud(n);
	for (int i = 0; i < n; ++i) {
		cin >> stud[i].first >> stud[i].second;
	}
	sort(stud.begin(), stud.end(), [&x, &k, &p](pair<char, int> &l, pair<char, int> &r){
		double dist1, dist2;
		if (l.first == 'A') {
			dist1 = x;
		}
		else {
			dist1 = k - (x + p);
		}
		if (r.first == 'A') {
			dist2 = x;
		}
		else {
			dist2 = k - (x + p);
		}
		return (dist1 / (double)l.second) < (dist2 / (double)r.second);
	});
	vector<double> timeToBridge(n);
	for (int i = 0; i < n; ++i) {
		if (stud[i].first == 'A') {
			timeToBridge[i] = (double)x / (double)stud[i].second;
		}
		else {
			timeToBridge[i] = (double)(k - (x + p)) / (double)stud[i].second;
		}
	}
	vector<double> timeAfterBridge(n);
	vector<double> timeOverBridge(n);
	for (int i = 0; i < n; ++i) {
		timeOverBridge[i] = p / (double)stud[i].second;
	}
	for (int i = 0; i < n; ++i) {
		if (stud[i].first == 'A') {
			timeAfterBridge[i] = (double)(k - (x + p)) / (double)stud[i].second;
		}
		else {
			timeAfterBridge[i] = (double)x / (double)stud[i].second;
		}
	}
	double curtime = 0;
	vector<double> studTime(n);
	vector<int> qfroma, qfromb;
	vector<bool> done(n, false);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (!done[j] && timeToBridge[j] <= curtime) {
				if (stud[j].first == 'A') {
					qfroma.push_back(i);
				}
				else {
					qfromb.push_back(i);
				}
			}
		}
		if (qfromb.empty() && qfroma.empty()) {
			curtime = timeToBridge[i];
			i--;
			continue;
		}
		int mx = -INF, ind = -1;
		char side = 'X';
		for (int j = 0; j < (int)qfroma.size(); ++j) {
			if (timeAfterBridge[qfroma[j]] + timeOverBridge[qfroma[j]] >= mx) {
				mx = qfroma[j];
				ind = j;
				side = 'A';
			}
		}
		for (int j = 0; j < (int)qfromb.size(); ++j) {
			if (timeAfterBridge[qfromb[j]] + timeOverBridge[qfromb[j]] >= mx) {
				mx = qfromb[j];
				ind = j;
				side = 'B';
			}
		}
		if (side == 'A') {
			done[qfroma[ind]] = true;
			studTime[qfroma[ind]] = curtime + timeOverBridge[qfroma[ind]] + timeAfterBridge[qfroma[ind]];
			curtime += timeOverBridge[qfroma[ind]];
			qfroma.erase(qfroma.begin() + ind);
		}
		else {
			done[qfromb[ind]] = true;
			studTime[qfromb[ind]] = curtime + timeOverBridge[qfromb[ind]] + timeAfterBridge[qfromb[ind]];
			curtime += timeOverBridge[qfromb[ind]];
			qfromb.erase(qfromb.begin() + ind);
		}
	}
	double last = *max_element(studTime.begin(), studTime.end());
	if (abs(last - (int)last) <= EPS) {
		last = (int)last;
	}
	last = ceil(last);
	cout << last;
}

signed main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
