﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>

using namespace std;

#define int long long

const int INF = 1e18;

string ToBaseX(int a, int x) {
	string res;
	while (a / x > 0) {
		res.push_back((a % x) + '0');
		a /= x;
	}
	res += to_string(a);
	reverse(res.begin(), res.end());
	return res;
}

struct DpCell {
	int val;
	unordered_set<int> path;

	DpCell() = default;

	DpCell(int val) : val(val) {}
};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	vector<vector<DpCell>> dp(n, vector<DpCell>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
			if (a[i][j] < 0) {
				a[i][j] = -INF;
			}
		}
	}
	dp[0][0] = DpCell(a[0][0]);
	dp[0][0].path.insert(a[0][0]);
	for (int i = 1; i < n; ++i) {
		if (a[i][0] >= 0 && dp[i - 1][0].path.find(a[i][0]) == dp[i - 1][0].path.end()) {
			dp[i][0].val = dp[i - 1][0].val + a[i][0];
			dp[i][0].path = dp[i - 1][0].path;
			dp[i][0].path.insert(a[i][0]);
		}
		else {
			dp[i][0].val = -INF;
		}
	}
	for (int i = 1; i < m; ++i) {
		if (a[0][i] >= 0 && dp[0][i - 1].path.find(a[0][i]) == dp[0][i - 1].path.end()) {
			dp[0][i].val = dp[0][i - 1].val + a[0][i];
			dp[0][i].path = dp[0][i - 1].path;
			dp[0][i].path.insert(a[0][i]);
		}
		else {
			dp[0][i].val = -INF;
		}
	}
	for (int i = 1; i < n; ++i) {
		for (int j = 1; j < m; ++j) {
			if (a[i][j] < 0) {
				dp[i][j].val = -INF;
				continue;
			}
			if (dp[i - 1][j].val > dp[i][j - 1].val && dp[i - 1][j].path.find(a[i][j]) == dp[i - 1][j].path.end()) {
				dp[i][j].val = dp[i - 1][j].val + a[i][j];
				dp[i][j].path = dp[i - 1][j].path;
				dp[i][j].path.insert(a[i][j]);
			}
			else if (dp[i][j - 1].path.find(a[i][j]) == dp[i][j - 1].path.end()) {
				dp[i][j].val = dp[i][j - 1].val + a[i][j];
				dp[i][j].path = dp[i][j - 1].path;
				dp[i][j].path.insert(a[i][j]);
			}
		}
	}
	int mx = -INF;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			mx = max(mx, dp[i][j].val);
		}
	}
	cout << mx;
}

signed main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
