﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <assert.h>

using namespace std;

const int INF = 1e9;

string ToBaseX(int a, int x) {
	string res;
	while (a / x > 0) {
		res.push_back((a % x) + '0');
		a /= x;
	}
	res += to_string(a);
	reverse(res.begin(), res.end());
	return res;
}


void solve() {
	int n, m;
	cin >> n >> m;
	assert(n <= 24);
	vector<set<int>> gr(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		gr[u].insert(v);
		gr[v].insert(u);
	}
	int N = (1 << n);
	set<int> used;
	int cnt = 0;
	for (int mask = 0; mask < N; ++mask) {
		vector<int> cur;
		for (int i = 0; i < n; ++i) {
			if (mask & (1 << i)) {
				cur.push_back(i);
			}
		}
		if (cur.size() < 4) {
			continue;
		}
		bool fl = true;
		for (int i = 0; i < (int)cur.size(); ++i) {
			for (int j = 0; j < (int)cur.size(); ++j) {
				if (i != j && gr[cur[i]].find(cur[j]) == gr[cur[i]].end()) {
					fl = false;
					break;
				}
			}
			if (!fl) {
				break;
			}
		}
		if (fl) {
			for (auto el : cur) {
				if (used.find(el) != used.end()) {
					fl = false;
					break;
				}
				used.insert(el);
			}
			if (fl) {
				cnt++;
			}
		}
	}
	cout << cnt;
}

signed main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
